using System;
using System.Data;
using MySql.Data.MySqlClient;

namespace MRJ.RecipeDB
{
//-------------------------------------------------------------------------------
// Purpose:
//  This interface is used for reading Recipe Information from the database.
//-------------------------------------------------------------------------------
public interface IRecipeRead
{
   void ListRatingsOfRecipe(int RecipeID, out DataSet list);
}

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
public class RecipeRead: Object, IRecipeRead
{


void IRecipeRead.ListRatingsOfRecipe(int RecipeID, out DataSet
list)
{
   MySqlCommand cmd;
   MySqlDataAdapter ad;
   MySqlConnection con;
   MySqlParameter prm;
   DataSet ds = null;

   try
   {
      ad = new MySqlDataAdapter();
      con = new MySqlConnection(Util.GetConnectionString());

      cmd = new MySqlCommand();
      cmd.Connection = con;

      // Tried this first:
//      cmd.CommandType = CommandType.StoredProcedure;
//      cmd.CommandText = "mj_spListRatingsOfRecipe";
//      prm = cmd.Parameters.Add("RecipeID", MySqlDbType.Int32);
//      prm.Value = RecipeID;

      // Tried this second:
//      cmd.CommandType = CommandType.Text;
//      cmd.CommandText = "SELECT r.Rating, r.Date, p.FirstName, p.LastName FROM Ratings r, Person p WHERE r.RecipeID = 8 AND r.PersonID = p.id ORDER BY r.Rating DESC, p.LastName, p.FirstName;";

//               // Tried this third:
      cmd.CommandType = CommandType.Text;
      cmd.CommandText = "SELECT r.Rating, p.FirstName, p.LastName FROM Ratings r, Person p WHERE r.RecipeID = 8 AND r.PersonID = p.id ORDER BY r.Rating DESC, p.LastName, p.FirstName;";

      ad.SelectCommand = cmd;

      ds = new DataSet();
      ad.Fill(ds);
   }
   catch(Exception exc)
   {
      Util.LogError(exc);
   }
   list = ds;
}
}
}
